unit glavno3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, podpora3;

type
  Tpodlaga = class(TForm)
    btVhod: TButton;
    btIzvedi: TButton;
    ed: TEdit;
    mem: TMemo;
    dlg: TOpenDialog;
    procedure btVhodClick(Sender: TObject);
    procedure btIzvediClick(Sender: TObject);
  private
    { Private declarations }
  public
    vol1, vol2, st: integer;
    predmeti: kElement;
    dat: text;
  end;

var
  podlaga: Tpodlaga;

implementation

{$R *.DFM}

procedure Tpodlaga.btVhodClick(Sender: TObject);
  var
    vrsta, vrsta1: string;
    meja, n: integer;
    novi: kElement;
begin
  if dlg.execute then begin
    predmeti:=nil;
    ed.text:=dlg.fileName;
    assignFile (dat, ed.text);
    reset (dat);
    readln (dat, vrsta);
    vol1:=strToInt (vrsta);
    readln (dat, vrsta);
    vol2:=strToInt (vrsta);
    readln (dat, vrsta);
    readln (dat, vrsta1);
    st:=0;
    repeat
      narediEl (novi);
      meja:=pos (' ', vrsta);
      if meja=0 then meja:=length (vrsta)+1;
      novi^.v1:=strToInt (copy (vrsta, 1, meja-1));
      vrsta:=copy (vrsta, meja+1, length (vrsta)-meja);
      meja:=pos (' ', vrsta1);
      if meja=0 then meja:=length (vrsta1)+1;
      novi^.c1:=strToInt (copy (vrsta1, 1, meja-1));
      vrsta1:=copy (vrsta1, meja+1, length (vrsta1)-meja);
      dodajEl (predmeti, novi);
      inc (st);
    until length (vrsta)=0;
    mem.lines.add ('Prostornina 1. nahrbtnika: '+intToStr (vol1));
    mem.lines.add ('Prostornina 2. nahrbtnika: '+intToStr (vol2));
    mem.lines.add ('Predmeti:');
    novi:=predmeti;
    for n:=1 to st do begin
      mem.lines.add (intToStr (n)+': '+intToStr (novi^.v1)+', '+intToStr (novi^.c1));
      novi:=novi^.naslednji;
    end;
    mem.lines.add ('');
  end;
end;

procedure Tpodlaga.btIzvediClick(Sender: TObject);
  var
    drevo, novo, trenutno: kVozlisce;
    novi, dodajani, razsirjani, kopirani, max, trenutni: kElement;
    n: integer;
    zacel, prva, nasel: boolean;
    nah1, nah2: string;
begin
  drevo:=nil;
  zacel:=true;
  narediVoz (novo);
  narediEl (novi);
  novi^.v1:=0;
  novi^.v2:=0;
  novi^.c1:=0;
  novi^.c2:=0;
  dodajEl (novo^.vrsta1, novi);
  dodajani:=predmeti;
  for n:=0 to st do begin
    if not zacel then begin
      narediVoz (novo);
      kopirani:=drevo^.vrsta1;
      prva:=true;
      while kopirani<>nil do begin
        if (kopirani^.v1<=vol1) and (kopirani^.v2<=vol2) then begin
          narediEl (novi);
          novi^.v1:=kopirani^.v1;
          novi^.v2:=kopirani^.v2;
          novi^.c1:=kopirani^.c1;
          novi^.c2:=kopirani^.c2;
          dodajEl (novo^.vrsta1, novi);
        end;
        kopirani:=kopirani^.naslednji;
        if (kopirani=nil) and prva then begin
          kopirani:=drevo^.vrsta2;
          prva:=false;
        end;
      end;
    end else zacel:=false;
    if n<st then begin
      razsirjani:=novo^.vrsta1;
      while razsirjani<>nil do begin
        narediEl (novi);
        novi^.v1:=razsirjani^.v1+dodajani^.v1;
        novi^.v2:=razsirjani^.v2;
        novi^.c1:=razsirjani^.c1+dodajani^.c1;
        novi^.c2:=razsirjani^.c2;
        novi^.nah:=1;
        novi^.iz:=razsirjani;
        dodajEl (novo^.vrsta2, novi);
        narediEl (novi);
        novi^.v1:=razsirjani^.v1;
        novi^.v2:=razsirjani^.v2+dodajani^.v1;
        novi^.c1:=razsirjani^.c1;
        novi^.c2:=razsirjani^.c2+dodajani^.c1;
        novi^.nah:=2;
        novi^.iz:=razsirjani;
        dodajEl (novo^.vrsta2, novi);
        razsirjani:=razsirjani^.naslednji;
      end;
      dodajani:=dodajani^.naslednji;
    end;
    dodajVoz (drevo, novo);
  end;
  trenutni:=drevo^.vrsta1;
  max:=trenutni;
  while trenutni<>nil do begin
    if trenutni^.c1+trenutni^.c2>max^.c1+max^.c2 then max:=trenutni;
    trenutni:=trenutni^.naslednji;
  end;
  nah1:='Vsebina 1. nahrbnika: ';
  nah2:='Vsebina 2. nahrbnika: ';
  trenutno:=drevo^.naslednje;
  for n:=1 to st do begin
    nasel:=false;
    trenutni:=trenutno^.vrsta2;
    while (trenutni<>nil) and not nasel do begin
      if (trenutni^.c1=max^.c1) and (trenutni^.c2=max^.c2) and (trenutni^.v1=max^.v1) and (trenutni^.v2=max^.v2) then begin
        if trenutni^.nah=1 then nah1:=nah1+intToStr (st-n+1)+' ' else nah2:=nah2+intToStr (st-n+1)+' ';
        max:=trenutni^.iz;
        nasel:=true;
      end;
      trenutni:=trenutni^.naslednji;
    end;
    trenutno:=trenutno^.naslednje;
  end;
  mem.lines.add (nah1);
  mem.lines.add (nah2);
(*  trenutno:=drevo;
  while trenutno<>nil do begin
    nah1:='';
    trenutni:=trenutno^.vrsta1;
    while trenutni<>nil do begin
      nah1:=nah1+'('+intToStr (trenutni^.v1)+', '+intToStr (trenutni^.c1)+', '+intToStr (trenutni^.v2)+', '+intToStr (trenutni^.c2)+', '+intToStr (trenutni^.nah)+') ';
      trenutni:=trenutni^.naslednji;
    end;
    mem.lines.add ('Vrsta1: '+nah1);
    nah1:='';
    trenutni:=trenutno^.vrsta2;
    while trenutni<>nil do begin
      nah1:=nah1+'('+intToStr (trenutni^.v1)+', '+intToStr (trenutni^.c1)+', '+intToStr (trenutni^.v2)+', '+intToStr (trenutni^.c2)+', '+intToStr (trenutni^.nah)+') ';
      trenutni:=trenutni^.naslednji;
    end;
    mem.lines.add ('Vrsta2: '+nah1);
    trenutno:=trenutno^.naslednje;
  end;*)
end;

end.
