unit podpora3;

interface

type
  kElement=^element;
  element=record
    v1, v2, c1, c2, nah: integer;
    naslednji, iz: kElement;
  end;
  kVozlisce=^vozlisce;
  vozlisce=record
    vrsta1: kElement;
    vrsta2: kElement;
    naslednje: kVozlisce;
  end;

procedure narediEl (var el: kElement);
procedure dodajEl (var sez: kElement; novi: kElement);
procedure narediVoz (var voz: kVozlisce);
procedure dodajVoz (var drevo: kVozlisce; novo: kVozlisce);

implementation

procedure narediEl (var el: kElement);
begin
  new (el);
  el^.naslednji:=nil;
end;

procedure dodajEl (var sez: kElement; novi: kElement);
begin
  novi^.naslednji:=sez;
  sez:=novi;
end;

procedure narediVoz (var voz: kVozlisce);
begin
  new (voz);
  voz^.vrsta1:=nil;
  voz^.vrsta2:=nil;
  voz^.naslednje:=nil;
end;

procedure dodajVoz (var drevo: kVozlisce; novo: kVozlisce);
(*  var zac: kVozlisce;*)
begin
(*  if drevo=nil then drevo:=novo else begin
    zac:=drevo;
    while zac^.naslednje<>nil do zac:=zac^.naslednje;
    zac^.naslednje:=novo;
  end;*)
  novo^.naslednje:=drevo;
  drevo:=novo;
end;

end.
